#!/usr/bin/env python3

from typing import *

# Example type annotations using the generic type List:
cities: List[str] = ["Stuttgart", "Paris", "Beijing"]

# TODO Annotate all variables and functions (arguments and return value) with the most specific type (e.g., not Any).

ages = {
    "Beatrice": 22,
    "Karim": 19,
    "John": 25,
    "Quan": 20,
}

points = {
    "John": 30.0,
    "Karim": 96.0,
    "Quan": 92.0,
    "Vasili": 60.0,
}

all_names = set()
for name in ages.keys():
    all_names.add(name)
for name in points.keys():
    all_names.add(name)

name_longest = ''

for name in all_names:
    age = ages.get(name)
    point = points.get(name)
    print(f'{name} is {age} years old and has {point} points.')

    if len(name) > len(name_longest):
        name_longest = name

print('Longest name:', name_longest)

def average(values):
    if not values:
        return None
    sum: int = 0
    for i in values:
        sum += i
    return sum / len(values)

age_avg = average(list(ages.values()))
print('Average age:', age_avg)

points_best = 0.0
student_best = None
for name, point in points.items():
    if point > points_best:
        points_best = point
        student_best = (name, point, ages.get(name))
print('Best student:', student_best)
